// Required: common.js

// RECORD_PO_ORDER GET
JSCUS_SQL._RECORD._PO_ORDER = function(){};

	/** 
	 * SP_GET Cache of ParameterSet (Array) 
	 */
	JSCUS_SQL._RECORD._PO_ORDER.PROPERTY_CACHED_QUERY = null;
	JSCUS_SQL._RECORD._PO_ORDER.PROPERTY_MODULE_ID = 40330;
	JSCUS_SQL._RECORD._PO_ORDER.PROPERTY_MODULE_CODE = 'record_po_order';
	
	
	/** 
	 * =======================================================================================================
	 * Perform SQL GET request to the table RECORD_PO_ORDER. Returns DataSet.
	 *
	 * @param VAR_PARAMETER_ARRAY String() Array with Request ParameterSet.
	 * @param CALLBACK_ADDRESS(bool, String) A callback method when the server response is received.
	 *
	 * @param SQL_KEEP_PARAMETER_TO_CACHE bool (Optional) If TRUE save to cache, for easier paging request.
	 * =======================================================================================================
	 */
	JSCUS_SQL._RECORD._PO_ORDER.CUS_GET_LITE = function
	(
		VAR_PARAMETER_ARRAY,
		CALLBACK_ADDRESS,
		
		SQL_KEEP_PARAMETER_TO_CACHE
	)
	{
		// Parameter Validation
		// _______________________________________________________________________
		JSVC_AV.VAR_VALIDATE_ARGUMENT_TYPE(VAR_PARAMETER_ARRAY, 'VAR_PARAMETER_ARRAY', 'ARRAY');
		
		// Handle Optionals
		// _______________________________________________________________________		
		SQL_KEEP_PARAMETER_TO_CACHE = JSVC_VAR.VAR_OPTIONAL(SQL_KEEP_PARAMETER_TO_CACHE, false);
		
		// Process SQL Request
		// _______________________________________________________________________
		var PARAM_SET = "";			
		PARAM_SET = JSRC_HTTP.REF_ADD(PARAM_SET, 'PARAM_REC_PORDER_ID', VAR_PARAMETER_ARRAY["PARAM_REC_PORDER_ID"]);
		PARAM_SET = JSRC_HTTP.REF_ADD(PARAM_SET, 'PARAM_REC_PORDER_CAT_COMPANY_ID', VAR_PARAMETER_ARRAY["PARAM_REC_PORDER_CAT_COMPANY_ID"]);
		PARAM_SET = JSRC_HTTP.REF_ADD(PARAM_SET, 'PARAM_REC_PORDER_CODE', VAR_PARAMETER_ARRAY["PARAM_REC_PORDER_CODE"]);
		PARAM_SET = JSRC_HTTP.REF_ADD(PARAM_SET, 'PARAM_REC_PORDER_INVOICE_CODE', VAR_PARAMETER_ARRAY["PARAM_REC_PORDER_INVOICE_CODE"]);
		PARAM_SET = JSRC_HTTP.REF_ADD(PARAM_SET, 'PARAM_REC_PORDER_AMOUNT_FROM', VAR_PARAMETER_ARRAY["PARAM_REC_PORDER_AMOUNT_FROM"]);
		PARAM_SET = JSRC_HTTP.REF_ADD(PARAM_SET, 'PARAM_REC_PORDER_AMOUNT_TO', VAR_PARAMETER_ARRAY["PARAM_REC_PORDER_AMOUNT_TO"]);
		PARAM_SET = JSRC_HTTP.REF_ADD(PARAM_SET, 'PARAM_REC_PORDER_REMARKS', VAR_PARAMETER_ARRAY["PARAM_REC_PORDER_REMARKS"]);
		PARAM_SET = JSRC_HTTP.REF_ADD(PARAM_SET, 'PARAM_REC_PORDER_DATE_EXPECT_FROM', VAR_PARAMETER_ARRAY["PARAM_REC_PORDER_DATE_EXPECT_FROM"]);
		PARAM_SET = JSRC_HTTP.REF_ADD(PARAM_SET, 'PARAM_REC_PORDER_DATE_EXPECT_TO', VAR_PARAMETER_ARRAY["PARAM_REC_PORDER_DATE_EXPECT_TO"]);
		PARAM_SET = JSRC_HTTP.REF_ADD(PARAM_SET, 'PARAM_REC_PORDER_DATE_DELIVERY_FROM', VAR_PARAMETER_ARRAY["PARAM_REC_PORDER_DATE_DELIVERY_FROM"]);
		PARAM_SET = JSRC_HTTP.REF_ADD(PARAM_SET, 'PARAM_REC_PORDER_DATE_DELIVERY_TO', VAR_PARAMETER_ARRAY["PARAM_REC_PORDER_DATE_DELIVERY_TO"]);
		PARAM_SET = JSRC_HTTP.REF_ADD(PARAM_SET, 'PARAM_REC_PORDER_ACC_ACCOUNT_ID', VAR_PARAMETER_ARRAY["PARAM_REC_PORDER_ACC_ACCOUNT_ID"]);
		PARAM_SET = JSRC_HTTP.REF_ADD(PARAM_SET, 'PARAM_REC_PORDER_DATE_REQUEST_FROM', VAR_PARAMETER_ARRAY["PARAM_REC_PORDER_DATE_REQUEST_FROM"]);
		PARAM_SET = JSRC_HTTP.REF_ADD(PARAM_SET, 'PARAM_REC_PORDER_DATE_REQUEST_TO', VAR_PARAMETER_ARRAY["PARAM_REC_PORDER_DATE_REQUEST_TO"]);
		PARAM_SET = JSRC_HTTP.REF_ADD(PARAM_SET, 'PARAM_REC_PORDER_STATUS', VAR_PARAMETER_ARRAY["PARAM_REC_PORDER_STATUS"]);
				
		PARAM_SET = JSRC_HTTP.REF_ADD(PARAM_SET, 'PARAM_ORDER_FIELD', VAR_PARAMETER_ARRAY["PARAM_ORDER_FIELD"]);
		PARAM_SET = JSRC_HTTP.REF_ADD(PARAM_SET, 'PARAM_ORDER_TYPE', VAR_PARAMETER_ARRAY["PARAM_ORDER_TYPE"]);
		PARAM_SET = JSRC_HTTP.REF_ADD(PARAM_SET, 'PARAM_SKIP', VAR_PARAMETER_ARRAY["PARAM_SKIP"]);
		PARAM_SET = JSRC_HTTP.REF_ADD(PARAM_SET, 'PARAM_LIMIT', VAR_PARAMETER_ARRAY["PARAM_LIMIT"]);
		
		// Copy Parameter To Cache
		// _______________________________________________________________________
		if(SQL_KEEP_PARAMETER_TO_CACHE == true)
		{
			JSCUS_SQL._RECORD._PO_ORDER.PROPERTY_CACHED_QUERY = VAR_PARAMETER_ARRAY;
		}
							
		// Send SQL Request
		// _______________________________________________________________________					
		CUS_SEND_REQUEST
		(
			CALLBACK_ADDRESS,
			JSCUS_CACHE.SERVER_URL + '/Record/po_order/get_lite',
			'',
			PARAM_SET
		);	
	};


	/** 
	 * =======================================================================================================
	 * Perform SQL GET request to the table RECORD_PO_ORDER. Returns DataSet.
	 *
	 * @param VAR_PARAMETER_ARRAY String() Array with Request ParameterSet.
	 * @param CALLBACK_ADDRESS(bool, String) A callback method when the server response is received.
	 *
	 * @param SQL_KEEP_PARAMETER_TO_CACHE bool (Optional) If TRUE save to cache, for easier paging request.
	 * =======================================================================================================
	 */
	JSCUS_SQL._RECORD._PO_ORDER.CUS_GET = function
	(
		VAR_PARAMETER_ARRAY,
		CALLBACK_ADDRESS,
		
		SQL_KEEP_PARAMETER_TO_CACHE
	)
	{
		// Parameter Validation
		// _______________________________________________________________________
		JSVC_AV.VAR_VALIDATE_ARGUMENT_TYPE(VAR_PARAMETER_ARRAY, 'VAR_PARAMETER_ARRAY', 'ARRAY');
		
		// Handle Optionals
		// _______________________________________________________________________		
		SQL_KEEP_PARAMETER_TO_CACHE = JSVC_VAR.VAR_OPTIONAL(SQL_KEEP_PARAMETER_TO_CACHE, false);
		
		// Process SQL Request
		// _______________________________________________________________________
		var PARAM_SET = "";			
		PARAM_SET = JSRC_HTTP.REF_ADD(PARAM_SET, 'PARAM_REC_PORDER_ID', VAR_PARAMETER_ARRAY["PARAM_REC_PORDER_ID"]);
		PARAM_SET = JSRC_HTTP.REF_ADD(PARAM_SET, 'PARAM_REC_PORDER_CAT_COMPANY_ID', VAR_PARAMETER_ARRAY["PARAM_REC_PORDER_CAT_COMPANY_ID"]);
		PARAM_SET = JSRC_HTTP.REF_ADD(PARAM_SET, 'PARAM_REC_PORDER_CODE', VAR_PARAMETER_ARRAY["PARAM_REC_PORDER_CODE"]);
		PARAM_SET = JSRC_HTTP.REF_ADD(PARAM_SET, 'PARAM_REC_PORDER_INVOICE_CODE', VAR_PARAMETER_ARRAY["PARAM_REC_PORDER_INVOICE_CODE"]);
		PARAM_SET = JSRC_HTTP.REF_ADD(PARAM_SET, 'PARAM_REC_PORDER_AMOUNT_FROM', VAR_PARAMETER_ARRAY["PARAM_REC_PORDER_AMOUNT_FROM"]);
		PARAM_SET = JSRC_HTTP.REF_ADD(PARAM_SET, 'PARAM_REC_PORDER_AMOUNT_TO', VAR_PARAMETER_ARRAY["PARAM_REC_PORDER_AMOUNT_TO"]);
		PARAM_SET = JSRC_HTTP.REF_ADD(PARAM_SET, 'PARAM_REC_PORDER_REMARKS', VAR_PARAMETER_ARRAY["PARAM_REC_PORDER_REMARKS"]);
		PARAM_SET = JSRC_HTTP.REF_ADD(PARAM_SET, 'PARAM_REC_PORDER_DATE_EXPECT_FROM', VAR_PARAMETER_ARRAY["PARAM_REC_PORDER_DATE_EXPECT_FROM"]);
		PARAM_SET = JSRC_HTTP.REF_ADD(PARAM_SET, 'PARAM_REC_PORDER_DATE_EXPECT_TO', VAR_PARAMETER_ARRAY["PARAM_REC_PORDER_DATE_EXPECT_TO"]);
		PARAM_SET = JSRC_HTTP.REF_ADD(PARAM_SET, 'PARAM_REC_PORDER_DATE_DELIVERY_FROM', VAR_PARAMETER_ARRAY["PARAM_REC_PORDER_DATE_DELIVERY_FROM"]);
		PARAM_SET = JSRC_HTTP.REF_ADD(PARAM_SET, 'PARAM_REC_PORDER_DATE_DELIVERY_TO', VAR_PARAMETER_ARRAY["PARAM_REC_PORDER_DATE_DELIVERY_TO"]);
		PARAM_SET = JSRC_HTTP.REF_ADD(PARAM_SET, 'PARAM_REC_PORDER_ACC_ACCOUNT_ID', VAR_PARAMETER_ARRAY["PARAM_REC_PORDER_ACC_ACCOUNT_ID"]);
		PARAM_SET = JSRC_HTTP.REF_ADD(PARAM_SET, 'PARAM_REC_PORDER_DATE_REQUEST_FROM', VAR_PARAMETER_ARRAY["PARAM_REC_PORDER_DATE_REQUEST_FROM"]);
		PARAM_SET = JSRC_HTTP.REF_ADD(PARAM_SET, 'PARAM_REC_PORDER_DATE_REQUEST_TO', VAR_PARAMETER_ARRAY["PARAM_REC_PORDER_DATE_REQUEST_TO"]);
		PARAM_SET = JSRC_HTTP.REF_ADD(PARAM_SET, 'PARAM_REC_PORDER_STATUS', VAR_PARAMETER_ARRAY["PARAM_REC_PORDER_STATUS"]);
				
		PARAM_SET = JSRC_HTTP.REF_ADD(PARAM_SET, 'PARAM_ORDER_FIELD', VAR_PARAMETER_ARRAY["PARAM_ORDER_FIELD"]);
		PARAM_SET = JSRC_HTTP.REF_ADD(PARAM_SET, 'PARAM_ORDER_TYPE', VAR_PARAMETER_ARRAY["PARAM_ORDER_TYPE"]);
		PARAM_SET = JSRC_HTTP.REF_ADD(PARAM_SET, 'PARAM_SKIP', VAR_PARAMETER_ARRAY["PARAM_SKIP"]);
		PARAM_SET = JSRC_HTTP.REF_ADD(PARAM_SET, 'PARAM_LIMIT', VAR_PARAMETER_ARRAY["PARAM_LIMIT"]);
		
		// Copy Parameter To Cache
		// _______________________________________________________________________
		if(SQL_KEEP_PARAMETER_TO_CACHE == true)
		{
			JSCUS_SQL._RECORD._PO_ORDER.PROPERTY_CACHED_QUERY = VAR_PARAMETER_ARRAY;
		}
							
		// Send SQL Request
		// _______________________________________________________________________					
		CUS_SEND_REQUEST
		(
			CALLBACK_ADDRESS,
			JSCUS_CACHE.SERVER_URL + '/Record/po_order/get',
			'',
			PARAM_SET
		);	
	};


	/** 
	 * =======================================================================================================
	 * Perform SQL GET request to the table RECORD_PO_ORDER. Returns DataSet.
	 *
	 * @param VAR_PARAMETER_ARRAY String() Array with Request ParameterSet.
	 * @param CALLBACK_ADDRESS(bool, String) A callback method when the server response is received.
	 *
	 * @param SQL_KEEP_PARAMETER_TO_CACHE bool (Optional) If TRUE save to cache, for easier paging request.
	 * =======================================================================================================
	 */
	JSCUS_SQL._RECORD._PO_ORDER.CUS_GET_ALL = function
	(
		VAR_PARAMETER_ARRAY,
		CALLBACK_ADDRESS,
		
		SQL_KEEP_PARAMETER_TO_CACHE
	)
	{
		// Parameter Validation
		// _______________________________________________________________________
		JSVC_AV.VAR_VALIDATE_ARGUMENT_TYPE(VAR_PARAMETER_ARRAY, 'VAR_PARAMETER_ARRAY', 'ARRAY');
		
		// Handle Optionals
		// _______________________________________________________________________		
		SQL_KEEP_PARAMETER_TO_CACHE = JSVC_VAR.VAR_OPTIONAL(SQL_KEEP_PARAMETER_TO_CACHE, false);
		
		// Process SQL Request
		// _______________________________________________________________________
		var PARAM_SET = "";			
		PARAM_SET = JSRC_HTTP.REF_ADD(PARAM_SET, 'PARAM_REC_PORDER_ID', VAR_PARAMETER_ARRAY["PARAM_REC_PORDER_ID"]);
		PARAM_SET = JSRC_HTTP.REF_ADD(PARAM_SET, 'PARAM_REC_PORDER_CAT_COMPANY_ID', VAR_PARAMETER_ARRAY["PARAM_REC_PORDER_CAT_COMPANY_ID"]);
		PARAM_SET = JSRC_HTTP.REF_ADD(PARAM_SET, 'PARAM_REC_PORDER_CODE', VAR_PARAMETER_ARRAY["PARAM_REC_PORDER_CODE"]);
		PARAM_SET = JSRC_HTTP.REF_ADD(PARAM_SET, 'PARAM_REC_PORDER_INVOICE_CODE', VAR_PARAMETER_ARRAY["PARAM_REC_PORDER_INVOICE_CODE"]);
		PARAM_SET = JSRC_HTTP.REF_ADD(PARAM_SET, 'PARAM_REC_PORDER_AMOUNT_FROM', VAR_PARAMETER_ARRAY["PARAM_REC_PORDER_AMOUNT_FROM"]);
		PARAM_SET = JSRC_HTTP.REF_ADD(PARAM_SET, 'PARAM_REC_PORDER_AMOUNT_TO', VAR_PARAMETER_ARRAY["PARAM_REC_PORDER_AMOUNT_TO"]);
		PARAM_SET = JSRC_HTTP.REF_ADD(PARAM_SET, 'PARAM_REC_PORDER_REMARKS', VAR_PARAMETER_ARRAY["PARAM_REC_PORDER_REMARKS"]);
		PARAM_SET = JSRC_HTTP.REF_ADD(PARAM_SET, 'PARAM_REC_PORDER_DATE_EXPECT_FROM', VAR_PARAMETER_ARRAY["PARAM_REC_PORDER_DATE_EXPECT_FROM"]);
		PARAM_SET = JSRC_HTTP.REF_ADD(PARAM_SET, 'PARAM_REC_PORDER_DATE_EXPECT_TO', VAR_PARAMETER_ARRAY["PARAM_REC_PORDER_DATE_EXPECT_TO"]);
		PARAM_SET = JSRC_HTTP.REF_ADD(PARAM_SET, 'PARAM_REC_PORDER_DATE_DELIVERY_FROM', VAR_PARAMETER_ARRAY["PARAM_REC_PORDER_DATE_DELIVERY_FROM"]);
		PARAM_SET = JSRC_HTTP.REF_ADD(PARAM_SET, 'PARAM_REC_PORDER_DATE_DELIVERY_TO', VAR_PARAMETER_ARRAY["PARAM_REC_PORDER_DATE_DELIVERY_TO"]);
		PARAM_SET = JSRC_HTTP.REF_ADD(PARAM_SET, 'PARAM_REC_PORDER_ACC_ACCOUNT_ID', VAR_PARAMETER_ARRAY["PARAM_REC_PORDER_ACC_ACCOUNT_ID"]);
		PARAM_SET = JSRC_HTTP.REF_ADD(PARAM_SET, 'PARAM_REC_PORDER_DATE_REQUEST_FROM', VAR_PARAMETER_ARRAY["PARAM_REC_PORDER_DATE_REQUEST_FROM"]);
		PARAM_SET = JSRC_HTTP.REF_ADD(PARAM_SET, 'PARAM_REC_PORDER_DATE_REQUEST_TO', VAR_PARAMETER_ARRAY["PARAM_REC_PORDER_DATE_REQUEST_TO"]);
		PARAM_SET = JSRC_HTTP.REF_ADD(PARAM_SET, 'PARAM_REC_PORDER_STATUS', VAR_PARAMETER_ARRAY["PARAM_REC_PORDER_STATUS"]);
		
		PARAM_SET = JSRC_HTTP.REF_ADD(PARAM_SET, 'PARAM_CAT_COMPANY_ID', VAR_PARAMETER_ARRAY["PARAM_CAT_COMPANY_ID"]);	
		PARAM_SET = JSRC_HTTP.REF_ADD(PARAM_SET, 'PARAM_CAT_COMPANY_DESCRIPTION', VAR_PARAMETER_ARRAY["PARAM_CAT_COMPANY_DESCRIPTION"]);	
		PARAM_SET = JSRC_HTTP.REF_ADD(PARAM_SET, 'PARAM_CAT_COMPANY_TIN', VAR_PARAMETER_ARRAY["PARAM_CAT_COMPANY_TIN"]);	
		PARAM_SET = JSRC_HTTP.REF_ADD(PARAM_SET, 'PARAM_CAT_COMPANY_ADDRESS', VAR_PARAMETER_ARRAY["PARAM_CAT_COMPANY_ADDRESS"]);	
		PARAM_SET = JSRC_HTTP.REF_ADD(PARAM_SET, 'PARAM_CAT_COMPANY_MOBILE', VAR_PARAMETER_ARRAY["PARAM_CAT_COMPANY_MOBILE"]);	
		PARAM_SET = JSRC_HTTP.REF_ADD(PARAM_SET, 'PARAM_CAT_COMPANY_PHONE', VAR_PARAMETER_ARRAY["PARAM_CAT_COMPANY_PHONE"]);	
		PARAM_SET = JSRC_HTTP.REF_ADD(PARAM_SET, 'PARAM_CAT_COMPANY_FAX', VAR_PARAMETER_ARRAY["PARAM_CAT_COMPANY_FAX"]);	
		PARAM_SET = JSRC_HTTP.REF_ADD(PARAM_SET, 'PARAM_CAT_COMPANY_EMAIL', VAR_PARAMETER_ARRAY["PARAM_CAT_COMPANY_EMAIL"]);	
		PARAM_SET = JSRC_HTTP.REF_ADD(PARAM_SET, 'PARAM_CAT_COMPANY_WEBSITE', VAR_PARAMETER_ARRAY["PARAM_CAT_COMPANY_WEBSITE"]);	
		PARAM_SET = JSRC_HTTP.REF_ADD(PARAM_SET, 'PARAM_CAT_COMPANY_SNS_PAGE', VAR_PARAMETER_ARRAY["PARAM_CAT_COMPANY_SNS_PAGE"]);	
		PARAM_SET = JSRC_HTTP.REF_ADD(PARAM_SET, 'PARAM_CAT_COMPANY_COMPANY_TYPE', VAR_PARAMETER_ARRAY["PARAM_CAT_COMPANY_COMPANY_TYPE"]);	
		PARAM_SET = JSRC_HTTP.REF_ADD(PARAM_SET, 'PARAM_CAT_COMPANY_REMARKS', VAR_PARAMETER_ARRAY["PARAM_CAT_COMPANY_REMARKS"]);	
		PARAM_SET = JSRC_HTTP.REF_ADD(PARAM_SET, 'PARAM_CAT_COMPANY_STATUS', VAR_PARAMETER_ARRAY["PARAM_CAT_COMPANY_STATUS"]);	
		PARAM_SET = JSRC_HTTP.REF_ADD(PARAM_SET, 'PARAM_CAT_COMPANY_SYSTEM_GENERATED', VAR_PARAMETER_ARRAY["PARAM_CAT_COMPANY_SYSTEM_GENERATED"]);	
		PARAM_SET = JSRC_HTTP.REF_ADD(PARAM_SET, 'PARAM_ACC_ACCOUNT_ID', VAR_PARAMETER_ARRAY["PARAM_ACC_ACCOUNT_ID"]);	
		PARAM_SET = JSRC_HTTP.REF_ADD(PARAM_SET, 'PARAM_ACC_ACCOUNT_SERVER_ID', VAR_PARAMETER_ARRAY["PARAM_ACC_ACCOUNT_SERVER_ID"]);	
		PARAM_SET = JSRC_HTTP.REF_ADD(PARAM_SET, 'PARAM_ACC_ACCOUNT_ACC_LEVEL_ID', VAR_PARAMETER_ARRAY["PARAM_ACC_ACCOUNT_ACC_LEVEL_ID"]);	
		PARAM_SET = JSRC_HTTP.REF_ADD(PARAM_SET, 'PARAM_ACC_ACCOUNT_ACC_GROUP_ID', VAR_PARAMETER_ARRAY["PARAM_ACC_ACCOUNT_ACC_GROUP_ID"]);	
		PARAM_SET = JSRC_HTTP.REF_ADD(PARAM_SET, 'PARAM_ACC_ACCOUNT_ADD_RESOURCE_ID', VAR_PARAMETER_ARRAY["PARAM_ACC_ACCOUNT_ADD_RESOURCE_ID"]);	
		PARAM_SET = JSRC_HTTP.REF_ADD(PARAM_SET, 'PARAM_ACC_ACCOUNT_USERNAME', VAR_PARAMETER_ARRAY["PARAM_ACC_ACCOUNT_USERNAME"]);	
		PARAM_SET = JSRC_HTTP.REF_ADD(PARAM_SET, 'PARAM_ACC_ACCOUNT_PASSWORD', VAR_PARAMETER_ARRAY["PARAM_ACC_ACCOUNT_PASSWORD"]);	
		PARAM_SET = JSRC_HTTP.REF_ADD(PARAM_SET, 'PARAM_ACC_ACCOUNT_AUTH_CODE', VAR_PARAMETER_ARRAY["PARAM_ACC_ACCOUNT_AUTH_CODE"]);	
		PARAM_SET = JSRC_HTTP.REF_ADD(PARAM_SET, 'PARAM_ACC_ACCOUNT_FIRST_NAME', VAR_PARAMETER_ARRAY["PARAM_ACC_ACCOUNT_FIRST_NAME"]);	
		PARAM_SET = JSRC_HTTP.REF_ADD(PARAM_SET, 'PARAM_ACC_ACCOUNT_MIDDLE_NAME', VAR_PARAMETER_ARRAY["PARAM_ACC_ACCOUNT_MIDDLE_NAME"]);	
		PARAM_SET = JSRC_HTTP.REF_ADD(PARAM_SET, 'PARAM_ACC_ACCOUNT_LAST_NAME', VAR_PARAMETER_ARRAY["PARAM_ACC_ACCOUNT_LAST_NAME"]);	
		PARAM_SET = JSRC_HTTP.REF_ADD(PARAM_SET, 'PARAM_ACC_ACCOUNT_POSITION', VAR_PARAMETER_ARRAY["PARAM_ACC_ACCOUNT_POSITION"]);	
		PARAM_SET = JSRC_HTTP.REF_ADD(PARAM_SET, 'PARAM_ACC_ACCOUNT_SYS_GENDER_ID', VAR_PARAMETER_ARRAY["PARAM_ACC_ACCOUNT_SYS_GENDER_ID"]);	
		PARAM_SET = JSRC_HTTP.REF_ADD(PARAM_SET, 'PARAM_ACC_ACCOUNT_STATUS', VAR_PARAMETER_ARRAY["PARAM_ACC_ACCOUNT_STATUS"]);	
		PARAM_SET = JSRC_HTTP.REF_ADD(PARAM_SET, 'PARAM_ACC_ACCOUNT_SYSTEM_GENERATED', VAR_PARAMETER_ARRAY["PARAM_ACC_ACCOUNT_SYSTEM_GENERATED"]);	
				
		PARAM_SET = JSRC_HTTP.REF_ADD(PARAM_SET, 'PARAM_ORDER_FIELD', VAR_PARAMETER_ARRAY["PARAM_ORDER_FIELD"]);
		PARAM_SET = JSRC_HTTP.REF_ADD(PARAM_SET, 'PARAM_ORDER_TYPE', VAR_PARAMETER_ARRAY["PARAM_ORDER_TYPE"]);
		PARAM_SET = JSRC_HTTP.REF_ADD(PARAM_SET, 'PARAM_SKIP', VAR_PARAMETER_ARRAY["PARAM_SKIP"]);
		PARAM_SET = JSRC_HTTP.REF_ADD(PARAM_SET, 'PARAM_LIMIT', VAR_PARAMETER_ARRAY["PARAM_LIMIT"]);
		
		// Copy Parameter To Cache
		// _______________________________________________________________________
		if(SQL_KEEP_PARAMETER_TO_CACHE == true)
		{
			JSCUS_SQL._RECORD._PO_ORDER.PROPERTY_CACHED_QUERY = VAR_PARAMETER_ARRAY;
		}
							
		// Send SQL Request
		// _______________________________________________________________________					
		CUS_SEND_REQUEST
		(
			CALLBACK_ADDRESS,
			JSCUS_CACHE.SERVER_URL + '/Record/po_order/get_all',
			'',
			PARAM_SET
		);	
	};
	
	
		/** 
	 * =======================================================================================================
	 * Perform SQL GET request to the table RECORD_PO_ORDER. Returns DataSet.
	 *
	 * @param VAR_PARAMETER_ARRAY String() Array with Request ParameterSet.
	 * @param CALLBACK_ADDRESS(bool, String) A callback method when the server response is received.
	 *
	 * @param SQL_KEEP_PARAMETER_TO_CACHE bool (Optional) If TRUE save to cache, for easier paging request.
	 * =======================================================================================================
	 */
	JSCUS_SQL._RECORD._PO_ORDER.CUS_GET_SUM = function
	(
		VAR_PARAMETER_ARRAY,
		CALLBACK_ADDRESS,
		
		SQL_KEEP_PARAMETER_TO_CACHE
	)
	{
		// Parameter Validation
		// _______________________________________________________________________
		JSVC_AV.VAR_VALIDATE_ARGUMENT_TYPE(VAR_PARAMETER_ARRAY, 'VAR_PARAMETER_ARRAY', 'ARRAY');
		
		// Handle Optionals
		// _______________________________________________________________________		
		SQL_KEEP_PARAMETER_TO_CACHE = JSVC_VAR.VAR_OPTIONAL(SQL_KEEP_PARAMETER_TO_CACHE, false);
		
		// Process SQL Request
		// _______________________________________________________________________
		var PARAM_SET = "";			
		PARAM_SET = JSRC_HTTP.REF_ADD(PARAM_SET, 'PARAM_REC_PORDER_ID', VAR_PARAMETER_ARRAY["PARAM_REC_PORDER_ID"]);
		PARAM_SET = JSRC_HTTP.REF_ADD(PARAM_SET, 'PARAM_REC_PORDER_CAT_COMPANY_ID', VAR_PARAMETER_ARRAY["PARAM_REC_PORDER_CAT_COMPANY_ID"]);
		PARAM_SET = JSRC_HTTP.REF_ADD(PARAM_SET, 'PARAM_REC_PORDER_CODE', VAR_PARAMETER_ARRAY["PARAM_REC_PORDER_CODE"]);
		PARAM_SET = JSRC_HTTP.REF_ADD(PARAM_SET, 'PARAM_REC_PORDER_INVOICE_CODE', VAR_PARAMETER_ARRAY["PARAM_REC_PORDER_INVOICE_CODE"]);
		PARAM_SET = JSRC_HTTP.REF_ADD(PARAM_SET, 'PARAM_REC_PORDER_AMOUNT_FROM', VAR_PARAMETER_ARRAY["PARAM_REC_PORDER_AMOUNT_FROM"]);
		PARAM_SET = JSRC_HTTP.REF_ADD(PARAM_SET, 'PARAM_REC_PORDER_AMOUNT_TO', VAR_PARAMETER_ARRAY["PARAM_REC_PORDER_AMOUNT_TO"]);
		PARAM_SET = JSRC_HTTP.REF_ADD(PARAM_SET, 'PARAM_REC_PORDER_REMARKS', VAR_PARAMETER_ARRAY["PARAM_REC_PORDER_REMARKS"]);
		PARAM_SET = JSRC_HTTP.REF_ADD(PARAM_SET, 'PARAM_REC_PORDER_DATE_EXPECT_FROM', VAR_PARAMETER_ARRAY["PARAM_REC_PORDER_DATE_EXPECT_FROM"]);
		PARAM_SET = JSRC_HTTP.REF_ADD(PARAM_SET, 'PARAM_REC_PORDER_DATE_EXPECT_TO', VAR_PARAMETER_ARRAY["PARAM_REC_PORDER_DATE_EXPECT_TO"]);
		PARAM_SET = JSRC_HTTP.REF_ADD(PARAM_SET, 'PARAM_REC_PORDER_DATE_DELIVERY_FROM', VAR_PARAMETER_ARRAY["PARAM_REC_PORDER_DATE_DELIVERY_FROM"]);
		PARAM_SET = JSRC_HTTP.REF_ADD(PARAM_SET, 'PARAM_REC_PORDER_DATE_DELIVERY_TO', VAR_PARAMETER_ARRAY["PARAM_REC_PORDER_DATE_DELIVERY_TO"]);
		PARAM_SET = JSRC_HTTP.REF_ADD(PARAM_SET, 'PARAM_REC_PORDER_ACC_ACCOUNT_ID', VAR_PARAMETER_ARRAY["PARAM_REC_PORDER_ACC_ACCOUNT_ID"]);
		PARAM_SET = JSRC_HTTP.REF_ADD(PARAM_SET, 'PARAM_REC_PORDER_DATE_REQUEST_FROM', VAR_PARAMETER_ARRAY["PARAM_REC_PORDER_DATE_REQUEST_FROM"]);
		PARAM_SET = JSRC_HTTP.REF_ADD(PARAM_SET, 'PARAM_REC_PORDER_DATE_REQUEST_TO', VAR_PARAMETER_ARRAY["PARAM_REC_PORDER_DATE_REQUEST_TO"]);
		PARAM_SET = JSRC_HTTP.REF_ADD(PARAM_SET, 'PARAM_REC_PORDER_STATUS', VAR_PARAMETER_ARRAY["PARAM_REC_PORDER_STATUS"]);
				
		PARAM_SET = JSRC_HTTP.REF_ADD(PARAM_SET, 'PARAM_ORDER_FIELD', VAR_PARAMETER_ARRAY["PARAM_ORDER_FIELD"]);
		PARAM_SET = JSRC_HTTP.REF_ADD(PARAM_SET, 'PARAM_ORDER_TYPE', VAR_PARAMETER_ARRAY["PARAM_ORDER_TYPE"]);
		PARAM_SET = JSRC_HTTP.REF_ADD(PARAM_SET, 'PARAM_SKIP', VAR_PARAMETER_ARRAY["PARAM_SKIP"]);
		PARAM_SET = JSRC_HTTP.REF_ADD(PARAM_SET, 'PARAM_LIMIT', VAR_PARAMETER_ARRAY["PARAM_LIMIT"]);
		
		// Copy Parameter To Cache
		// _______________________________________________________________________
		if(SQL_KEEP_PARAMETER_TO_CACHE == true)
		{
			JSCUS_SQL._RECORD._PO_ORDER.PROPERTY_CACHED_QUERY = VAR_PARAMETER_ARRAY;
		}
							
		// Send SQL Request
		// _______________________________________________________________________					
		CUS_SEND_REQUEST
		(
			CALLBACK_ADDRESS,
			JSCUS_CACHE.SERVER_URL + '/Record/po_order/get_sum',
			'',
			PARAM_SET
		);	
	};
	
	
	/** 
	 * =======================================================================================================
	 * Populate SP-GET request request parameters with default value.
	 * =======================================================================================================
	 */
	JSCUS_SQL._RECORD._PO_ORDER.CUS_PREPARE_MAPPED_ARRAY_FOR_GET = function()
	{
		// Initialize
		var RESULT_MAPARRAY = [];

		// Populate default fields
		RESULT_MAPARRAY["PARAM_REC_PORDER_ID"] = FLAG_BIGINT_NULL;
		RESULT_MAPARRAY["PARAM_REC_PORDER_CAT_COMPANY_ID"] = FLAG_BIGINT_NULL;
		RESULT_MAPARRAY["PARAM_REC_PORDER_CODE"] = FLAG_NVARCHAR_NULL;
		RESULT_MAPARRAY["PARAM_REC_PORDER_INVOICE_CODE"] = FLAG_NVARCHAR_NULL;
		RESULT_MAPARRAY["PARAM_REC_PORDER_AMOUNT_FROM"] = FLAG_DECIMAL_NULL;
		RESULT_MAPARRAY["PARAM_REC_PORDER_AMOUNT_TO"] = FLAG_DECIMAL_NULL;
		RESULT_MAPARRAY["PARAM_REC_PORDER_REMARKS"] = FLAG_NVARCHAR_NULL;
		RESULT_MAPARRAY["PARAM_REC_PORDER_DATE_EXPECT_FROM"] = FLAG_DATETIME_NULL;
		RESULT_MAPARRAY["PARAM_REC_PORDER_DATE_EXPECT_TO"] = FLAG_DATETIME_NULL;					
		RESULT_MAPARRAY["PARAM_REC_PORDER_DATE_DELIVERY_FROM"] = FLAG_DATETIME_NULL;
		RESULT_MAPARRAY["PARAM_REC_PORDER_DATE_DELIVERY_TO"] = FLAG_DATETIME_NULL;					
		RESULT_MAPARRAY["PARAM_REC_PORDER_ACC_ACCOUNT_ID"] = FLAG_BIGINT_NULL;
		RESULT_MAPARRAY["PARAM_REC_PORDER_DATE_REQUEST_FROM"] = FLAG_DATETIME_NULL;
		RESULT_MAPARRAY["PARAM_REC_PORDER_DATE_REQUEST_TO"] = FLAG_DATETIME_NULL;					
		RESULT_MAPARRAY["PARAM_REC_PORDER_STATUS"] = FLAG_TINYINT_NULL;
		
		
		RESULT_MAPARRAY["PARAM_CAT_COMPANY_ID"] = FLAG_BIGINT_NULL,	
		RESULT_MAPARRAY["PARAM_CAT_COMPANY_DESCRIPTION"] = FLAG_NVARCHAR_NULL,	
		RESULT_MAPARRAY["PARAM_CAT_COMPANY_TIN"] = FLAG_NVARCHAR_NULL,	
		RESULT_MAPARRAY["PARAM_CAT_COMPANY_ADDRESS"] = FLAG_NVARCHAR_NULL,	
		RESULT_MAPARRAY["PARAM_CAT_COMPANY_MOBILE"] = FLAG_NVARCHAR_NULL,	
		RESULT_MAPARRAY["PARAM_CAT_COMPANY_PHONE"] = FLAG_NVARCHAR_NULL,	
		RESULT_MAPARRAY["PARAM_CAT_COMPANY_FAX"] = FLAG_NVARCHAR_NULL,	
		RESULT_MAPARRAY["PARAM_CAT_COMPANY_EMAIL"] = FLAG_NVARCHAR_NULL,	
		RESULT_MAPARRAY["PARAM_CAT_COMPANY_WEBSITE"] = FLAG_NVARCHAR_NULL,	
		RESULT_MAPARRAY["PARAM_CAT_COMPANY_SNS_PAGE"] = FLAG_NVARCHAR_NULL,	
		RESULT_MAPARRAY["PARAM_CAT_COMPANY_COMPANY_TYPE"] = FLAG_NVARCHAR_NULL,	
		RESULT_MAPARRAY["PARAM_CAT_COMPANY_REMARKS"] = FLAG_NVARCHAR_NULL,	
		RESULT_MAPARRAY["PARAM_CAT_COMPANY_STATUS"] = FLAG_TINYINT_NULL,	
		RESULT_MAPARRAY["PARAM_CAT_COMPANY_SYSTEM_GENERATED"] = FLAG_TINYINT_NULL,	
		RESULT_MAPARRAY["PARAM_ACC_ACCOUNT_ID"] = FLAG_BIGINT_NULL,	
		RESULT_MAPARRAY["PARAM_ACC_ACCOUNT_SERVER_ID"] = FLAG_BIGINT_NULL,	
		RESULT_MAPARRAY["PARAM_ACC_ACCOUNT_ACC_LEVEL_ID"] = FLAG_BIGINT_NULL,	
		RESULT_MAPARRAY["PARAM_ACC_ACCOUNT_ACC_GROUP_ID"] = FLAG_BIGINT_NULL,	
		RESULT_MAPARRAY["PARAM_ACC_ACCOUNT_ADD_RESOURCE_ID"] = FLAG_BIGINT_NULL,	
		RESULT_MAPARRAY["PARAM_ACC_ACCOUNT_USERNAME"] = FLAG_NVARCHAR_NULL,	
		RESULT_MAPARRAY["PARAM_ACC_ACCOUNT_PASSWORD"] = FLAG_NVARCHAR_NULL,	
		RESULT_MAPARRAY["PARAM_ACC_ACCOUNT_AUTH_CODE"] = FLAG_NVARCHAR_NULL,	
		RESULT_MAPARRAY["PARAM_ACC_ACCOUNT_FIRST_NAME"] = FLAG_NVARCHAR_NULL,	
		RESULT_MAPARRAY["PARAM_ACC_ACCOUNT_MIDDLE_NAME"] = FLAG_NVARCHAR_NULL,	
		RESULT_MAPARRAY["PARAM_ACC_ACCOUNT_LAST_NAME"] = FLAG_NVARCHAR_NULL,	
		RESULT_MAPARRAY["PARAM_ACC_ACCOUNT_POSITION"] = FLAG_NVARCHAR_NULL,	
		RESULT_MAPARRAY["PARAM_ACC_ACCOUNT_SYS_GENDER_ID"] = FLAG_BIGINT_NULL,	
		RESULT_MAPARRAY["PARAM_ACC_ACCOUNT_STATUS"] = FLAG_TINYINT_NULL,	
		RESULT_MAPARRAY["PARAM_ACC_ACCOUNT_SYSTEM_GENERATED"] = FLAG_TINYINT_NULL,	
		
		
		// Paging Parameters
		RESULT_MAPARRAY["PARAM_ORDER_FIELD"] = "REC_PORDER_DATE_EXPECT";
		RESULT_MAPARRAY["PARAM_ORDER_TYPE"] = "DESC";
		RESULT_MAPARRAY["PARAM_SKIP"] = 0;
		RESULT_MAPARRAY["PARAM_LIMIT"] = JSCUS_CACHE.SITE_SHOW_RESULT_PER_PAGE_PLAIN_TEXT;

		// Return prepared MapArray
		return RESULT_MAPARRAY;
	};
	
	
	/** 
	 * =======================================================================================================
	 * Reload current page in query, stored at SQL cache.
	 * =======================================================================================================
	 */
	JSCUS_SQL._RECORD._PO_ORDER.CUS_GET_CACHE = function
	(
		CALLBACK_ADDRESS
	)
	{
		JSCUS_SQL._RECORD._PO_ORDER.CUS_GET
		(
			JSCUS_SQL._RECORD._PO_ORDER.PROPERTY_CACHED_QUERY,
			CALLBACK_ADDRESS
		);
	};
	
	/**
	 * =======================================================================================================
	 * Resets a value within the SQL cache to NULLs.
	 * =======================================================================================================
	 */
	JSCUS_SQL._RECORD._PO_ORDER.CUS_GET_CACHE_CLEAR = function()
	{
		JSCUS_SQL._RECORD._PO_ORDER.PROPERTY_CACHED_QUERY = null;
	};
				
	/** 
	 * =======================================================================================================
	 * Load First page in query, stored at SQL cache.
	 * =======================================================================================================
	 */
	JSCUS_SQL._RECORD._PO_ORDER.CUS_GET_CACHE_MOVE_FIRST = function
	(
		CALLBACK_ADDRESS
	)
	{
		// Adjust Paging
		// ...........................................
		JSCUS_SQL._RECORD._PO_ORDER.PROPERTY_CACHED_QUERY["PARAM_SKIP"] = 0;

		// Return ParameterSet
		// ...........................................
		JSCUS_SQL._RECORD._PO_ORDER.CUS_GET_CACHE(CALLBACK_ADDRESS);
	};


	/**
     * =======================================================================================================
	 * <summary>Load Previous page in query, stored at SQL cache.</summary>
	 * =======================================================================================================
	 */
	JSCUS_SQL._RECORD._PO_ORDER.CUS_GET_CACHE_MOVE_PREV = function
	(
		CALLBACK_ADDRESS
	)
	{
		// Initialize
		// ...........................................
		var PARAM_SKIP = JSVC_NUM.VAR_NVALL(JSCUS_SQL._RECORD._PO_ORDER.PROPERTY_CACHED_QUERY["PARAM_SKIP"]);
		var PARAM_LIMIT = JSVC_NUM.VAR_NVALL(JSCUS_SQL._RECORD._PO_ORDER.PROPERTY_CACHED_QUERY["PARAM_LIMIT"]);

		// Adjust Paging
		// ...........................................
		if(PARAM_SKIP > PARAM_LIMIT)
		{
			JSCUS_SQL._RECORD._PO_ORDER.PROPERTY_CACHED_QUERY["PARAM_SKIP"] = PARAM_SKIP - PARAM_LIMIT;
		}
		else
		{
			JSCUS_SQL._RECORD._PO_ORDER.PROPERTY_CACHED_QUERY["PARAM_SKIP"] = 0;
		}

		// Request Query
		// ...........................................
		if(JSVC_NUM.VAR_NVALL(JSCUS_SQL._RECORD._PO_ORDER.PROPERTY_CACHED_QUERY["PARAM_SKIP"]) != PARAM_SKIP)
		{
			JSCUS_SQL._RECORD._PO_ORDER.CUS_GET_CACHE(CALLBACK_ADDRESS);
			return true;
		}
		else
		{
			return false;	
		}		
	};


	/**
	 * =======================================================================================================
	 * Load Next page in query, stored at SQL cache.
	 * =======================================================================================================
	 */
	JSCUS_SQL._RECORD._PO_ORDER.CUS_GET_CACHE_MOVE_NEXT = function
	(
		CALLBACK_ADDRESS
	)
	{
		// Initialize
		// ...........................................
		var PARAM_SKIP = JSVC_NUM.VAR_NVALL(JSCUS_SQL._RECORD._PO_ORDER.PROPERTY_CACHED_QUERY["PARAM_SKIP"]);
		var PARAM_LIMIT = JSVC_NUM.VAR_NVALL(JSCUS_SQL._RECORD._PO_ORDER.PROPERTY_CACHED_QUERY["PARAM_LIMIT"]);

		// Adjust Paging
		// ...........................................
		JSCUS_SQL._RECORD._PO_ORDER.PROPERTY_CACHED_QUERY["PARAM_SKIP"] = PARAM_SKIP + PARAM_LIMIT;

		// Request Query
		// ...........................................
		JSCUS_SQL._RECORD._PO_ORDER.CUS_GET_CACHE(CALLBACK_ADDRESS);
	};
	
	// =======================================================================================================

	
	/**
	 * =======================================================================================================
	 * Perform SQL GET requests to the table RECORD_PO_ORDER, and populate Form/ComboBox/DataGridViewComboBoxColumn with the request result.
	 * Form/ComboBox/DataGridViewComboBoxColumn to Populate.
	 *
	 * @param Method CALLBACK_ADDRESS A Method to be called on Completion.
	 * @param Control CONTROL_VAR A Control to Populate.
	 * @param Boolean KEEP_RECORD If TRUE keeps the current items when populating ComboBox/ListBox.
	 * @param Byte RECORD_STATUS For Filtering a status of retrieving query.
	 *
	 * @return JSON String used to populate the control. (At Callback Address)
	 * =======================================================================================================
	 */
	JSCUS_SQL._RECORD._PO_ORDER.CUS_GET_THEN_POPULATE_EXECUTE = function
	(
		CALLBACK_ADDRESS,
		
		CONTROL_VAR, 
		KEEP_RECORD,
		RECORD_STATUS,
		PARAM_REC_PORDER_ID,
		MAPPED_ARRAY_PARAMS
	)
	{	
		// Parameter Validation
		// _______________________________________________________________________
		JSVC_AV.VAR_VALIDATE_NULL(CALLBACK_ADDRESS, "CALLBACK_ADDRESS")
		JSVC_AV.VAR_VALIDATE_NULL(CONTROL_VAR, "CONTROL_VAR")
		JSVC_AV.VAR_VALIDATE_ARGUMENT_TYPE(KEEP_RECORD, 'KEEP_RECORD', 'BOOLEAN');
		JSVC_AV.VAR_VALIDATE_ARGUMENT_TYPE(RECORD_STATUS, 'RECORD_STATUS', 'NUMERIC');
		JSVC_AV.VAR_VALIDATE_ARGUMENT_TYPE(PARAM_REC_PORDER_ID, 'PARAM_REC_PORDER_ID', 'NUMERIC');
		
		// Handle Optionals
		// _______________________________________________________________________
		PARAM_REC_PORDER_ID = JSVC_VAR.VAR_OPTIONAL(PARAM_REC_PORDER_ID, FLAG_BIGINT_NULL);		
		
		// Initialize
		// _______________________________________________________________________
		if(JSVC_VAR.VAR_ISSET(MAPPED_ARRAY_PARAMS) == false)
		{
			MAPPED_ARRAY_PARAMS = JSCUS_SQL._RECORD._PO_ORDER.CUS_PREPARE_MAPPED_ARRAY_FOR_GET();
			MAPPED_ARRAY_PARAMS["PARAM_REC_PORDER_ID"] = PARAM_REC_PORDER_ID;
			MAPPED_ARRAY_PARAMS["PARAM_REC_PORDER_STATUS"] = RECORD_STATUS;		
		}		
	

		// Request Query
		// _______________________________________________________________________
		if
		(
			(
				JSVC_VAR.VAR_ISSET(CONTROL_VAR.TYPEOF) &&
				CONTROL_VAR.TYPEOF() == "DataGridView"
			) ||
			JSOC_ELEMENT.VAR_IS_PANEL(CONTROL_VAR)
		)
		{
			JSCUS_SQL._RECORD._PO_ORDER.CUS_GET
			(
				MAPPED_ARRAY_PARAMS, 
				function
				(
					IS_SUCCESS, RESPONSE_STRING
				)
				{
					JSCUS_SQL._RECORD._PO_ORDER.CUS_GET_THEN_POPULATE_EXECUTE_ON_RESPONSE
					(
						IS_SUCCESS, RESPONSE_STRING,
						CALLBACK_ADDRESS, CONTROL_VAR, KEEP_RECORD, RECORD_STATUS, 
						PARAM_REC_PORDER_ID
					);
				}, 
				false
			);		
		}
		else
		{
			JSCUS_SQL._RECORD._PO_ORDER.CUS_GET_LITE
			(
				MAPPED_ARRAY_PARAMS, 
				function
				(
					IS_SUCCESS, RESPONSE_STRING
				)
				{
					JSCUS_SQL._RECORD._PO_ORDER.CUS_GET_THEN_POPULATE_EXECUTE_ON_RESPONSE
					(
						IS_SUCCESS, RESPONSE_STRING,
						CALLBACK_ADDRESS, CONTROL_VAR, KEEP_RECORD, RECORD_STATUS, 
						PARAM_REC_PORDER_ID
					);
				}, 
				false
			);		
		}	
	};
	
	/**
	 * Continuation on CUS_GET_THEN_POPULATE_EXECUTE(). Handles response from server.
	 */
	JSCUS_SQL._RECORD._PO_ORDER.CUS_GET_THEN_POPULATE_EXECUTE_ON_RESPONSE = function
	(
		IS_SUCCESS, RESPONSE_STRING,
		CALLBACK_ADDRESS, CONTROL_VAR, KEEP_RECORD, RECORD_STATUS, 
		PARAM_REC_PORDER_ID
	)
	{
		// Request failure (connection)
		// ...........................................
		if(IS_SUCCESS != true)
		{
			return null;
		}

		// Catch JSON Error
		// ...........................................
		else if(JSRC_JSON.REF_IS_JSTRING(RESPONSE_STRING) == false)
		{
			JSOC_DIALOG.VAR_MESSAGE_BOX
			(
				'Server error - please contact the system administrator : <br />' + RESPONSE_STRING,
				'Information',
				'OK', 'ERROR',
				null
			);	
			return;			
		}
	
		// Populate DataGridViewComboBoxColumn
		// ...........................................
		if
		(
			JSVC_VAR.VAR_ISSET(CONTROL_VAR.TYPEOF) &&
			CONTROL_VAR.TYPEOF() == "DataGridView"
		)
		{
			CONTROL_VAR.POPULATE_FROM_QUERY 
			(
				RESPONSE_STRING,
				null,
				KEEP_RECORD,
				false,
				1,
				["2", "1"]
			);
			return null;
		}
								
		// Populate ComboBox Multiples
		// ...........................................
		if(JSVC_VAR.VAR_IS_ARRAY(CONTROL_VAR) && JSOC_ELEMENT.VAR_IS_SELECT(CONTROL_VAR[0]))
		{
			var ARRAY_INDEX = 0;
			while(CONTROL_VAR.length > ARRAY_INDEX)
			{
				JSOC_CMB.VAR_ADD_FROM_JSON
				(
					CONTROL_VAR[ARRAY_INDEX],  RESPONSE_STRING,
					"REC_PORDER_ID",
					"REC_PORDER_CODE",
					KEEP_RECORD, false
				);				
				ARRAY_INDEX ++;
			}
			CALLBACK_ADDRESS(true, RESPONSE_STRING);
			return null;
		}

		// Populate ComboBox Single
		// ...........................................
		if(JSOC_ELEMENT.VAR_IS_SELECT(CONTROL_VAR))
		{
			JSOC_CMB.VAR_ADD_FROM_JSON
				(
					CONTROL_VAR,  RESPONSE_STRING,
					"REC_PORDER_ID",
					"REC_PORDER_CODE",
					KEEP_RECORD, false
				);		
			CALLBACK_ADDRESS(true, RESPONSE_STRING);
			return null;
		}
							
		// Populate Form
		// ...........................................
		if(JSOC_ELEMENT.VAR_IS_PANEL(CONTROL_VAR))
		{
			JSOC_WINDOW.VAR_POPULATE_FROM_QUERY(CONTROL_VAR,  RESPONSE_STRING, ["2", "1"]);
			CALLBACK_ADDRESS(true, RESPONSE_STRING);
			return null;
		}
		
		// Return Result
		// ...........................................
		CALLBACK_ADDRESS(true, RESPONSE_STRING);
		return null;
	};

	/**
	 * =======================================================================================================
	 * Perform SQL GET requests to the table RECORD_PO_ORDER, and populate Form with the request result. Combobox items should be pre-populated.
	 * @param FORM_VAR Parent-Element of the sub-elements to Populate.
	 * =======================================================================================================
	 */
	JSCUS_SQL._RECORD._PO_ORDER.CUS_GET_THEN_POPULATE_FORM = function
	(
		CALLBACK_ADDRESS,
		
		FORM_VAR, 
		RECORD_STATUS,
		
		PARAM_REC_PORDER_ID,
		MAPPED_ARRAY_PARAMS
	)
	{
		return JSCUS_SQL._RECORD._PO_ORDER.CUS_GET_THEN_POPULATE_EXECUTE
		(
			CALLBACK_ADDRESS,
			
			FORM_VAR, 
			false, 
			RECORD_STATUS, 		
			PARAM_REC_PORDER_ID,
			MAPPED_ARRAY_PARAMS
		);
	};
		
		
	
	/**
	 * =======================================================================================================
	 * Perform SQL GET requests to the table RECORD_PO_ORDER, and populate ComboBox with the request result.
	 * @param COMBOBOX_VAR ComboBox to Populate.
	 * =======================================================================================================
	 */
	JSCUS_SQL._RECORD._PO_ORDER.CUS_GET_THEN_POPULATE_COMBOBOX = function 
	(
		CALLBACK_ADDRESS,
		
		COMBOBOX_VAR,
		KEEP_RECORD,	
		RECORD_STATUS,
		MAPPED_ARRAY_PARAMS
	)
	{
		return JSCUS_SQL._RECORD._PO_ORDER.CUS_GET_THEN_POPULATE_EXECUTE 
			(
				CALLBACK_ADDRESS,
				
				COMBOBOX_VAR,
				KEEP_RECORD,
				RECORD_STATUS,			
				FLAG_BIGINT_NULL,					
				MAPPED_ARRAY_PARAMS
			);
	};
				
	/** 
	 * =======================================================================================================
	 * <summary>Perform SQL GET requests to the table RECORD_PO_ORDER, and populate DataGridViewComboBoxColumn with the request result.</summary>
	 * <param name="COMBOBOX_VAR">DataGridViewComboBoxColumn to Populate.</param>
	 * =======================================================================================================
	 */
	JSCUS_SQL._RECORD._PO_ORDER.CUS_GET_THEN_POPULATE_DGV = function
	(
		CALLBACK_ADDRESS,
		
		DGV_VAR, 
		KEEP_RECORD,
		RECORD_STATUS,
		MAPPED_ARRAY_PARAMS
	)
	{
		return JSCUS_SQL._RECORD._PO_ORDER.CUS_GET_THEN_POPULATE_EXECUTE
			(
				CALLBACK_ADDRESS,
				
				DGV_VAR, 
				KEEP_RECORD,
				RECORD_STATUS,			
				FLAG_BIGINT_NULL,
				MAPPED_ARRAY_PARAMS
			);		
	};
	// =======================================================================================================
	
	/** 
	 * =======================================================================================================
	 * Perform SQL SAVE request to the table RECORD_PO_ORDER. Returns DataSet.
	 *
	 * @param VAR_PARAMETER_ARRAY Array with Request ParameterSet.
	 * @param CALLBACK_ADDRESS(bool, String) A callback method when the server response is received.
	 * @param FORWARDED_RESPONSE_STRING(String[]) Used internally. Ignore this parameter when calling this function.
	 * =======================================================================================================
	 */
	JSCUS_SQL._RECORD._PO_ORDER.CUS_SAVE = function
	(
		VAR_PARAMETER_ARRAY,
		CALLBACK_ADDRESS,
		FORWARDED_RESPONSE_STRING
	)
	{
		// Parameter Validation
		// _______________________________________________________________________
		JSVC_AV.VAR_VALIDATE_ARGUMENT_TYPE(VAR_PARAMETER_ARRAY, 'VAR_PARAMETER_ARRAY', 'ARRAY');
		
		// Process SQL Request
		// _______________________________________________________________________
		var PARAM_SET = "";	
		var ARRAY_INDEX = 0;
		var RAW_VAR_PARAMETER_ARRAY = JSVC_ARR.VAR_CLONE(VAR_PARAMETER_ARRAY);
		
		if(JSVC_VAR.VAR_IS_ARRAY(VAR_PARAMETER_ARRAY[0]) == true)
		{
			// Check limits per request 
			if(VAR_PARAMETER_ARRAY.length > CUSTOM_SITE_ARRAY_REQUEST_LIMIT)
			{
				throw "HTTP request is too large for single request. Limit : " + CUSTOM_SITE_ARRAY_REQUEST_LIMIT;
			}
			
			// Populate Array Items
			while(VAR_PARAMETER_ARRAY.length > 0 && ARRAY_INDEX < CUSTOM_SITE_ARRAY_REQUEST_LIMIT)
			{
				PARAM_SET = JSRC_HTTP.REF_ADD(PARAM_SET, 'PARAM_REC_PORDER_ID[]', VAR_PARAMETER_ARRAY[0]["PARAM_REC_PORDER_ID"]);
				PARAM_SET = JSRC_HTTP.REF_ADD(PARAM_SET, 'PARAM_REC_PORDER_CAT_COMPANY_ID[]',  VAR_PARAMETER_ARRAY[0]["PARAM_REC_PORDER_CAT_COMPANY_ID"]);
				PARAM_SET = JSRC_HTTP.REF_ADD(PARAM_SET, 'PARAM_REC_PORDER_CODE[]',  VAR_PARAMETER_ARRAY[0]["PARAM_REC_PORDER_CODE"]);
				PARAM_SET = JSRC_HTTP.REF_ADD(PARAM_SET, 'PARAM_REC_PORDER_INVOICE_CODE[]',  VAR_PARAMETER_ARRAY[0]["PARAM_REC_PORDER_INVOICE_CODE"]);
				PARAM_SET = JSRC_HTTP.REF_ADD(PARAM_SET, 'PARAM_REC_PORDER_REMARKS[]',  VAR_PARAMETER_ARRAY[0]["PARAM_REC_PORDER_REMARKS"]);
				PARAM_SET = JSRC_HTTP.REF_ADD(PARAM_SET, 'PARAM_REC_PORDER_DATE_EXPECT[]',  VAR_PARAMETER_ARRAY[0]["PARAM_REC_PORDER_DATE_EXPECT"]);
				PARAM_SET = JSRC_HTTP.REF_ADD(PARAM_SET, 'PARAM_REC_PORDER_DATE_DELIVERY[]',  VAR_PARAMETER_ARRAY[0]["PARAM_REC_PORDER_DATE_DELIVERY"]);
				PARAM_SET = JSRC_HTTP.REF_ADD(PARAM_SET, 'PARAM_REC_PORDER_STATUS[]',  VAR_PARAMETER_ARRAY[0]["PARAM_REC_PORDER_STATUS"]);
				if(JSVC_VAR.VAR_ISSET(VAR_PARAMETER_ARRAY[0]["PARAM_REC_PORDER_ID_FILE"]))
				{
					PARAM_SET = JSRC_HTTP.REF_ADD(PARAM_SET, 'PARAM_REC_PORDER_ID_FILE[]',  VAR_PARAMETER_ARRAY[0]["PARAM_REC_PORDER_ID_FILE"]);
				}
				if(ARRAY_INDEX == 0)
				{
					PARAM_SET = JSRC_HTTP.REF_ADD(PARAM_SET, 'PARAM_REQUEST_UNIQUE_VALUE',  VAR_PARAMETER_ARRAY[0]["PARAM_REQUEST_UNIQUE_VALUE"]);
				}
				VAR_PARAMETER_ARRAY.shift();
				ARRAY_INDEX ++;
			}					
		}
		else
		{
			PARAM_SET = JSRC_HTTP.REF_ADD(PARAM_SET, 'PARAM_REC_PORDER_ID[]', VAR_PARAMETER_ARRAY["PARAM_REC_PORDER_ID"]);
			PARAM_SET = JSRC_HTTP.REF_ADD(PARAM_SET, 'PARAM_REC_PORDER_CAT_COMPANY_ID[]',  VAR_PARAMETER_ARRAY["PARAM_REC_PORDER_CAT_COMPANY_ID"]);
			PARAM_SET = JSRC_HTTP.REF_ADD(PARAM_SET, 'PARAM_REC_PORDER_CODE[]',  VAR_PARAMETER_ARRAY["PARAM_REC_PORDER_CODE"]);
			PARAM_SET = JSRC_HTTP.REF_ADD(PARAM_SET, 'PARAM_REC_PORDER_INVOICE_CODE[]',  VAR_PARAMETER_ARRAY["PARAM_REC_PORDER_INVOICE_CODE"]);
			PARAM_SET = JSRC_HTTP.REF_ADD(PARAM_SET, 'PARAM_REC_PORDER_REMARKS[]',  VAR_PARAMETER_ARRAY["PARAM_REC_PORDER_REMARKS"]);
			PARAM_SET = JSRC_HTTP.REF_ADD(PARAM_SET, 'PARAM_REC_PORDER_DATE_EXPECT[]',  VAR_PARAMETER_ARRAY["PARAM_REC_PORDER_DATE_EXPECT"]);
			PARAM_SET = JSRC_HTTP.REF_ADD(PARAM_SET, 'PARAM_REC_PORDER_DATE_DELIVERY[]',  VAR_PARAMETER_ARRAY["PARAM_REC_PORDER_DATE_DELIVERY"]);
			PARAM_SET = JSRC_HTTP.REF_ADD(PARAM_SET, 'PARAM_REC_PORDER_STATUS[]',  VAR_PARAMETER_ARRAY["PARAM_REC_PORDER_STATUS"]);
			if(JSVC_VAR.VAR_ISSET(VAR_PARAMETER_ARRAY["PARAM_REC_PORDER_ID_FILE"]))
			{
				PARAM_SET = JSRC_HTTP.REF_ADD(PARAM_SET, 'PARAM_REC_PORDER_ID_FILE[]',  VAR_PARAMETER_ARRAY["PARAM_REC_PORDER_ID_FILE"]);
			}
			PARAM_SET = JSRC_HTTP.REF_ADD(PARAM_SET, 'PARAM_REQUEST_UNIQUE_VALUE',  VAR_PARAMETER_ARRAY["PARAM_REQUEST_UNIQUE_VALUE"]);
		}

		// Send SQL Request [Splitted multi-request]
		// _______________________________________________________________________	
		if(VAR_PARAMETER_ARRAY.length > 0)
		{	
			CUS_SEND_REQUEST
			(
				function(IS_SUCCESS, RESPONSE_STRING)
				{
					// Merge RESPONSE_STRING
					// ...........................................
					if(JSVC_VAR.VAR_IS_ARRAY(FORWARDED_RESPONSE_STRING))
					{
						FORWARDED_RESPONSE_STRING.push(RESPONSE_STRING);
					}
					else if(JSVC_STR.VAR_IS_BLANK(FORWARDED_RESPONSE_STRING))
					{
						FORWARDED_RESPONSE_STRING = RESPONSE_STRING;
					}
					else
					{
						FORWARDED_RESPONSE_STRING = [FORWARDED_RESPONSE_STRING, RESPONSE_STRING];
					}
					
					// Validate
					// ...........................................
					if(IS_SUCCESS === false)
					{
						CALLBACK_ADDRESS(IS_SUCCESS, RESPONSE_STRING, RAW_VAR_PARAMETER_ARRAY);
						return;
					}
					
					// Validate JSON Response
					// ...........................................
					var JSON_OBJECT = JSRC_JSON.REF_CREATE(RESPONSE_STRING);
					if(JSRC_JSON.REF_IS_SUCCESS(JSON_OBJECT) === false)
					{
						CALLBACK_ADDRESS(IS_SUCCESS, RESPONSE_STRING, RAW_VAR_PARAMETER_ARRAY);
						return;
					}		
					
					// To next request
					// ...........................................	
					JSCUS_SQL._RECORD._PO_ORDER.CUS_SAVE
					(
						VAR_PARAMETER_ARRAY,
						CALLBACK_ADDRESS,
						FORWARDED_RESPONSE_STRING
					);
				},
				JSCUS_CACHE.SERVER_URL + '/Record/po_order/save',
				JSCUS_CACHE.SERVER_URL + '/System/nonce/get',
				PARAM_SET
			);		
		}
		
		// Send SQL Request [One-time request]
		// _______________________________________________________________________
		else
		{
			CUS_SEND_REQUEST
			(
				function(IS_SUCCESS, RESPONSE_STRING)
				{
					// Merge RESPONSE_STRING
					// ...........................................
					if(JSVC_VAR.VAR_IS_ARRAY(FORWARDED_RESPONSE_STRING))
					{
						FORWARDED_RESPONSE_STRING.push(RESPONSE_STRING);
					}
					else if(JSVC_STR.VAR_IS_BLANK(FORWARDED_RESPONSE_STRING))
					{
						FORWARDED_RESPONSE_STRING = RESPONSE_STRING;
					}
					else
					{
						FORWARDED_RESPONSE_STRING = [FORWARDED_RESPONSE_STRING, RESPONSE_STRING];
					}
					
					// Validate
					// ...........................................
					if(IS_SUCCESS === false)
					{
						CALLBACK_ADDRESS(IS_SUCCESS, RESPONSE_STRING, RAW_VAR_PARAMETER_ARRAY);
						return;
					}
					
					// Validate JSON Response
					// ...........................................
					var JSON_OBJECT = JSRC_JSON.REF_CREATE(RESPONSE_STRING);
					if(JSRC_JSON.REF_IS_SUCCESS(JSON_OBJECT) === false)
					{
						CALLBACK_ADDRESS(IS_SUCCESS, RESPONSE_STRING, RAW_VAR_PARAMETER_ARRAY);
						return;
					}		
					
					// Execute callback
					// ...........................................
					CALLBACK_ADDRESS(IS_SUCCESS, FORWARDED_RESPONSE_STRING);
				},
				JSCUS_CACHE.SERVER_URL + '/Record/po_order/save',
				JSCUS_CACHE.SERVER_URL + '/System/nonce/get',
				PARAM_SET
			);	
		}
	};
	
	/** 
	 * =======================================================================================================
	 * Populate SP-SAVE request parameters with default value.
	 * =======================================================================================================
	 */
	JSCUS_SQL._RECORD._PO_ORDER.CUS_PREPARE_MAPPED_ARRAY_FOR_SAVE = function()
	{
		// Initialize
		var RESULT_MAPARRAY = [];

		// Populate default fields
		RESULT_MAPARRAY["PARAM_REC_PORDER_ID"] = FLAG_BIGINT_NULL;
		RESULT_MAPARRAY["PARAM_REC_PORDER_CAT_COMPANY_ID"] = FLAG_BIGINT_NULL;
		RESULT_MAPARRAY["PARAM_REC_PORDER_CODE"] = FLAG_NVARCHAR_NULL;
		RESULT_MAPARRAY["PARAM_REC_PORDER_INVOICE_CODE"] = FLAG_NVARCHAR_NULL;
		RESULT_MAPARRAY["PARAM_REC_PORDER_REMARKS"] = FLAG_NVARCHAR_NULL;
		RESULT_MAPARRAY["PARAM_REC_PORDER_DATE_EXPECT"] = FLAG_DATETIME_NULL;
		RESULT_MAPARRAY["PARAM_REC_PORDER_DATE_DELIVERY"] = FLAG_DATETIME_NULL;
		RESULT_MAPARRAY["PARAM_REC_PORDER_STATUS"] = FLAG_TINYINT_NULL;
		RESULT_MAPARRAY["PARAM_REC_PORDER_ID_FILE"] = null;
		RESULT_MAPARRAY["PARAM_REQUEST_UNIQUE_VALUE"] = '';
		
		
		// Return prepared MapArray
		return RESULT_MAPARRAY;		
	};
	
	/** 
	 * =======================================================================================================
	 * Add SP-GET request for multiple record save request.
	 * =======================================================================================================
	 */	
	JSCUS_SQL._RECORD._PO_ORDER.CUS_ADD_MAPPED_ARRAY_FOR_SAVE = function
	(
		VAR_GROUPED_PARAMETER_ARRAY,
		VAR_ADD_PARAMETER_ARRAY
	)
	{
		// Parameter Validation
		// _______________________________________________________________________
		JSVC_AV.VAR_VALIDATE_ARGUMENT_TYPE(VAR_GROUPED_PARAMETER_ARRAY, 'VAR_GROUPED_PARAMETER_ARRAY', 'ARRAY');
		JSVC_AV.VAR_VALIDATE_ARGUMENT_TYPE(VAR_ADD_PARAMETER_ARRAY, 'VAR_ADD_PARAMETER_ARRAY', 'ARRAY');
		
		// Push ParameterSet
		// _______________________________________________________________________
		VAR_GROUPED_PARAMETER_ARRAY.push(VAR_ADD_PARAMETER_ARRAY);
		return VAR_GROUPED_PARAMETER_ARRAY;
	};
	/** 
	 * =======================================================================================================
	 * Perform SQL DELETE request to the table RECORD_PO_ORDER. Returns DataSet.
	 *
	 * @param PARAM_REC_PORDER_ID Primary Key ID, Can be Array.
	 * @param CALLBACK_ADDRESS(bool, String) A callback method when the server response is received.
	 * =======================================================================================================
	 */
	JSCUS_SQL._RECORD._PO_ORDER.CUS_DELETE = function
	(
		PARAM_REC_PORDER_ID,
		CALLBACK_ADDRESS
	)
	{
		// Parameter Validation
		// _______________________________________________________________________
		JSVC_AV.VAR_VALIDATE_ARGUMENT_TYPE(PARAM_REC_PORDER_ID, 'PARAM_REC_PORDER_ID', 'ARRAY, NUMERIC');
	
		// Process SQL Request
		// _______________________________________________________________________	
		var PARAM_SET = "";
		var ARRAY_INDEX = 0;
		
		if(JSVC_VAR.VAR_IS_ARRAY(PARAM_REC_PORDER_ID) == true)
		{
			// Check limits per request 
			if(PARAM_REC_PORDER_ID.length >= CUSTOM_SITE_ARRAY_REQUEST_LIMIT)
			{
				throw "HTTP request is too large for single request. Limit : " + CUSTOM_SITE_ARRAY_REQUEST_LIMIT;
			}
			
			// Populate Array Items
			while(PARAM_REC_PORDER_ID.length > 0 && ARRAY_INDEX < CUSTOM_SITE_ARRAY_REQUEST_LIMIT)
			{
				PARAM_SET = JSRC_HTTP.REF_ADD('', 'PARAM_REC_PORDER_ID[]', PARAM_REC_PORDER_ID[ARRAY_INDEX]);
			
				PARAM_REC_PORDER_ID.shift();
				ARRAY_INDEX ++;
			}	
		}
		else
		{
			PARAM_SET = JSRC_HTTP.REF_ADD('', 'PARAM_REC_PORDER_ID[]', PARAM_REC_PORDER_ID);
		}

		// Send SQL Request
		// _______________________________________________________________________				
		CUS_SEND_REQUEST
		(
			CALLBACK_ADDRESS,
			JSCUS_CACHE.SERVER_URL + '/Record/po_order/delete',
			JSCUS_CACHE.SERVER_URL + '/System/nonce/get',
			PARAM_SET
		);	
	};